=== debian/changelog ===
corsix-th (0.68.0-1) unstable; urgency=medium

  * New upstream version 0.68.0
  * Change my email address

 -- Alexandre Detiste <tchet@debian.org>  Tue, 22 Oct 2024 18:23:20 +0200
