=== debian/watch ===
version=4
opts=uversionmangle=s/-/~/,\
s/v([^\/]+)\.tar\.gz/v$1\/CorsixTH-$1\.tar\.gz/;\
s/$/.sig/ \
 https://github.com/CorsixTH/CorsixTH/tags (?:.*/)?v?@ANY_VERSION@@ARCHIVE_EXT@
