## corsix-th 0.69.0

=== debian/changelog ===
corsix-th (0.69.0-1) unstable; urgency=medium

  * New upstream version 0.69.0
  * Switch to X-Style: black

  [ Phil Morrell ]
  * Revert "there is no GPG signature"

 -- Alexandre Detiste <tchet@debian.org>  Mon, 21 Jul 2025 22:43:58 +0200
