=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
  Alexandre Detiste <tchet@debian.org>,
  Phil Morrell <debian@emorrp1.name>,
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  imagemagick,
  libavcodec-dev,
  libavformat-dev,
@@ -24,6 +24,7 @@
 Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
 Vcs-Browser: https://salsa.debian.org/games-team/corsix-th
 Rules-Requires-Root: no
+X-Style: black
 
 Package: corsix-th
 Architecture: any
