## corsix-th 0.69.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,21 +1,28 @@
 # Cmake File for CorsixTH
 # OPTIONS AVAILABLE:
 # Any of the following: (default)
+
+# CorsixTH Features and behaviour
 #   - WITH_AUDIO      : Activate sound (yes)
 #   - WITH_FREETYPE2  : Active support for non-Latin script alphabets (yes)
+#   - WITH_FONT       : Path of a font that will be used if the user does not set one (empty, Arial on macOS)
 #   - WITH_MOVIES     : Activate movies (requires with_audio, FFmpeg) (yes)
-#   - WITH_LUAJIT     : Use LuaJIT instead of Lua (must specify library path) (no)
 #   - WITH_UPDATE_CHECK : Activates support to check for new version on launch (requires libcurl) (yes)
 #   - USE_SOURCE_DATADIRS : Use the source directory for loading resources. Incompatible with the install target (no)
 #   - SEARCH_LOCAL_DATADIRS : Search resources in the working directory and the
 #       program directory where the executable stores. Makes the executable
 #       portable (yes for Apple)
 
-#   - WITH_VLD        : Build with Visual Leak Detector (requires Visual Studio) (no)
-#   - USE_PRECOMPILED_DEPS : Use precompiled dependencies on *nix (no)
+# Dependency resolution
+#   - WITH_LUAJIT     : Use LuaJIT instead of Lua (must specify library path) (no)
 #   - WITH_LUAROCKS : Install required luarocks in the macOS app (requires luarocks)
+#   - FETCH_CATCH2: Use FetchContent to obtain Catch2 if ENABLE_UNIT_TESTS=yes
 
+# Tests and debug options
 #   - ENABLE_UNIT_TESTS : Enable Unit Testing Target (requires Catch2) (no)
+#   - ENABLE_SANITIZERS : Build with AddressSanitizer (ASan) and UndefinedBehaviorSanitizer (UBSan) enabled (no)
+
+# Additional build targets
 #   - BUILD_ANIMVIEW : Generate AnimView build files (no)
 #   - BUILD_TOOLS : Generate cli tools
 
@@ -32,6 +39,7 @@
 option(ENABLE_UNIT_TESTS "Enables Unit Testing Targets" OFF)
 option(BUILD_ANIMVIEW "Build the animation viewer as part of the build process" OFF)
 option(BUILD_TOOLS "Build additional CLI tools (rnc_decode)" OFF)
+option(ENABLE_SANITIZERS "Build with ASan and UBSan enabled" OFF)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
 
@@ -56,8 +64,22 @@
 
 project(CorsixTH_Top_Level)
 
+if(ENABLE_UNIT_TESTS)
+  enable_testing()
+endif()
+
 if(MINGW)
   set(CMAKE_EXE_LINKER_FLAGS "-static-libgcc -static-libstdc++")
+endif()
+
+if(ENABLE_SANITIZERS)
+  if(MSVC)
+    # https://learn.microsoft.com/en-us/cpp/build/reference/fsanitize?view=msvc-170
+    add_compile_options(/fsanitize=address)
+  else()
+    add_compile_options(-fsanitize=address,undefined)
+    add_link_options(-fsanitize=address,undefined)
+  endif()
 endif()
 
 include(CheckIncludeFiles)
@@ -74,14 +96,16 @@
   "Search resources in the working directory and the program directory where the executable stores."
   ${SEARCH_LOCAL_DATADIRS_DEFAULT})
 
-if(MSVC)
-  option(WITH_VLD "Build with Visual Leak Detector for Visual Studio" OFF)
-endif()
-# Dependency management
-if(UNIX AND CMAKE_COMPILER_IS_GNU)
-  option(USE_PRECOMPILED_DEPS "Use Precompiled Dependencies" OFF) # Make *nix systems opt in
+if(WITH_FREETYPE2)
+  if(APPLE)
+    set(WITH_FONT_DEFAULT "/Library/Fonts/Arial Unicode.ttf")
+  else()
+    set(WITH_FONT_DEFAULT "")
+  endif()
+  set(WITH_FONT ${WITH_FONT_DEFAULT} CACHE FILEPATH "Use this font if one is not set in the game settings")
 endif()
 
+# Dependency management
 if(APPLE)
   option(WITH_LUAROCKS "Install required luarocks in the app" OFF)
 endif()
@@ -127,24 +151,6 @@
   set(CORSIX_TH_LINK_LUA_MODULES OFF)
 endif()
 
-if(MSVC)
-  if(WITH_VLD)
-    set(CORSIX_TH_USE_VLD ON)
-    message("Note: Visual Leak Detector is enabled")
-  else()
-    set(CORSIX_TH_USE_VLD OFF)
-    message("Note: Visual Leak Detector is disabled (default)")
-  endif()
-else()
-  set(CORSIX_TH_USE_VLD OFF)
-endif()
-
-# Get precompiled dependencies before running the various find modules
-if(USE_PRECOMPILED_DEPS)
-  message("Note: Using precompiled dependencies.")
-  include(PrecompiledDeps)
-endif()
-
 include(GNUInstallDirs)
 
 # Include individual projects
