=== libs/CMakeLists.txt ===
add_subdirectory(rnc)

if(SEARCH_LOCAL_DATADIRS)
  add_subdirectory(whereami)
endif()
