=== tools/CMakeLists.txt ===
add_subdirectory(rnc)
