=== CorsixTH/SrcUnshared/CMakeLists.txt ===
target_sources(CorsixTH
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
)
