=== debian/changelog ===
corsix-th (0.69.1-1) unstable; urgency=medium

  * New upstream version 0.69.1

 -- Alexandre Detiste <tchet@debian.org>  Sun, 24 Aug 2025 19:36:30 +0200
