=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: corsix-th
 Section: contrib/games
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Alexandre Detiste <tchet@debian.org>,
@@ -19,11 +18,10 @@
  libswscale-dev,
  lua-busted,
  lua5.4,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://corsixth.com
 Vcs-Git: https://salsa.debian.org/games-team/corsix-th.git
 Vcs-Browser: https://salsa.debian.org/games-team/corsix-th
-Rules-Requires-Root: no
 X-Style: black
 
 Package: corsix-th
