=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_BINDIR=/usr/games/ -DCMAKE_INSTALL_DATADIR=/usr/share/games/ -DWITH_UPDATE_CHECK=no

execute_after_dh_auto_install:
	rm -v debian/tmp/usr/share/games/corsix-th/LICENSE.txt

	for size in $$(identify ico:CorsixTH/CorsixTH.ico | awk '{print $$3}'); \
	do \
		mkdir -vp debian/corsix-th/usr/share/icons/hicolor/$$size/apps/ ; \
	done
	convert -verbose ico:CorsixTH/CorsixTH.ico -set filename:size %wx%h \
		debian/corsix-th/usr/share/icons/hicolor/%[filename:size]/apps/corsix-th.png

execute_after_dh_auto_test:
	busted -C CorsixTH/Luatest --verbose
